/**
 * Copyright 2019 DH
 * All right reserved.
 * 项目名称: 大恒泰山系统
 * 创建日期:2023/10/31
 */
package org.ts.ddcs.enums;

/*** 
 * Date:2023/10/31
 * Title:水文规约编码要素元数据定义
 * Description：对本文件的详细描述，原则上不能少于30字
 * @author dylan
 * @version 1.0
 * Remark：认为有必要的其他信息
 */
public enum SwElementCodeEnum {
    /**
     * 观测时间引导符
     */
    CODE_TT("F0", "TT"),

    /**
     * 测站编码引导符
     */
    CODE_ST("F1", "ST"),

    /**
     * 人工置数
     */
    CODE_RGZS("F2", "RGZS"),

    /**
     * 图片信息
     */
    CODE_PIC("F3", "PIC"),

    /**
     * 1 小时内每 5 分钟时段雨量 e（每组雨量占 1 字节
     * HEX，最大值 25.4 毫米，数据中不含小数点；FFH
     * 表示非法数据。）
     */
    CODE_DRP("F4", "DRP"),

    /**
     * 1 小时内 5 分钟间隔相对水位 1(每组水位占 2 字节
     * HEX，分辨力是为厘米，最大值为 655.34 米，数
     * 据中不含小数点；FFFFH 表示非法数据)；对于河道、
     * 闸坝（泵）站分别表示河道水位、闸（站）上水位。
     */
    CODE_DRZ1("F5", "DRZ1"),
    /**
     * 1 小时内 5 分钟间隔相对水位 2；对于闸坝（泵）
     * 站表示闸（站）下水位。
     */
    CODE_DRZ2("F6", "DRZ2"),
    /**
     * 1 小时内 5 分钟间隔相对水位 3
     */
    CODE_DRZ3("F7", "DRZ3"),
    /**
     * 1 小时内 5 分钟间隔相对水位 4
     */
    CODE_DRZ4("F8", "DRZ4"),
    /**
     * 1 小时内 5 分钟间隔相对水位 5
     */
    CODE_DRZ5("F9", "DRZ5"),
    /**
     * 1 小时内 5 分钟间隔相对水位 6
     */
    CODE_DRZ6("FA", "DRZ6"),
    /**
     * 1 小时内 5 分钟间隔相对水位 7
     */
    CODE_DRZ7("FB", "DRZ7"),
    /**
     * 1 小时内 5 分钟间隔相对水位 8
     */
    CODE_DRZ8("FC", "DRZ8"),
    /**
     * 流速批量数据传输
     */
    CODE_DATA("FD", "DATA"),
    /**
     * 断面面积
     */
    CODE_AC("01", "AC"),
    /**
     * 瞬时气温
     */
    CODE_AI("02", "AI"),
    /**
     * 瞬时水温
     */
    CODE_C("03", "C"),
    /**
     * 时间步长码
     */
    CODE_DRxnn("04", "DRxnn"),
    /**
     * 时段长,降水、引排水、抽水历时
     */
    CODE_DT("05", "DT"),
    /**
     * 日蒸发量
     */
    CODE_ED("06", "ED"),
    /**
     * 当前蒸发
     */
    CODE_EJ("07", "EJ"),
    /**
     * 气压
     */
    CODE_FL("08", "FL"),
    /**
     * 闸坝、水库闸门开启高度
     */
    CODE_GH("09", "GH"),
    /**
     * 输水设备、闸门(组)编号
     */
    CODE_GN("0A", "GN"),
    /**
     * 输水设备类别
     */
    CODE_GS("0B", "GS"),
    /**
     * 水库、闸坝闸门开启孔数
     */
    CODE_GT("0C", "GT"),
    /**
     * 地温
     */
    CODE_GTP("0D", "GTP"),
    /**
     * 地下水瞬时埋深
     */
    CODE_H("0E", "H"),
    /**
     * 波浪高度
     */
    CODE_HW("0F", "HW"),
    /**
     * 10 厘米处土壤含水量
     */
    CODE_M10("10", "M10"),
    /**
     * 20 厘米处土壤含水量
     */
    CODE_M20("11", "M20"),
    /**
     * 30 厘米处土壤含水量
     */
    CODE_M30("12", "M30"),
    /**
     * 40 厘米处土壤含水量
     */
    CODE_M40("13", "M40"),
    /**
     * 50 厘米处土壤含水量
     */
    CODE_M50("14", "M50"),
    /**
     * 60 厘米处土壤含水量
     */
    CODE_M60("15", "M60"),
    /**
     * 80 厘米处土壤含水量
     */
    CODE_M80("16", "M80"),
    /**
     * 100 厘米处土壤含水量
     */
    CODE_M100("17", "M100"),
    /**
     * 湿度
     */
    CODE_MST("18", "MST"),
    /**
     * 开机台数
     */
    CODE_NS("19", "NS"),
    /**
     * 1 小时时段降水量
     */
    CODE_P1("1A", "P1"),
    /**
     * 2 小时时段降水量
     */
    CODE_P2("1B", "P2"),
    /**
     * 3 小时时段降水量
     */
    CODE_P3("1C", "P3"),
    /**
     * 6 小时时段降水量
     */
    CODE_P6("1D", "P6"),
    /**
     * 12 小时时段降水量
     */
    CODE_P12("1E", "P12"),
    /**
     * 日降水量
     */
    CODE_PD("1F", "PD"),
    /**
     * 当前降水量
     */
    CODE_PJ("20", "PJ"),
    /**
     * 1 分钟时段降水量
     */
    CODE_PN01("21", "PN01"),
    /**
     * 5 分钟时段降水量
     */
    CODE_PN05("22", "PN05"),
    /**
     * 10 分钟时段降水量
     */
    CODE_PN10("23", "PN10"),
    /**
     * 30 分钟时段降水量
     */
    CODE_PN30("24", "PN30"),
    /**
     * 暴雨量
     */
    CODE_PR("25", "PR"),
    /**
     * 降水量累计值
     */
    CODE_PT("26", "PT"),
    /**
     * 瞬时流量、抽水流量
     */
    CODE_Q("27", "Q"),
    /**
     * 取(排）水口流量 1
     */
    CODE_Q1("28", "Q1"),
    /**
     * 取(排）水口流量 2
     */
    CODE_Q2("29", "Q2"),
    /**
     * 取(排）水口流量 3
     */
    CODE_Q3("2A", "Q3"),
    /**
     * 取(排）水口流量 4
     */
    CODE_Q4("2B", "Q4"),
    /**
     * 取(排）水口流量 5
     */
    CODE_Q5("2C", "Q5"),
    /**
     * 取(排）水口流量 6
     */
    CODE_Q6("2D", "Q6"),
    /**
     * 取(排）水口流量 7
     */
    CODE_Q7("2E", "Q7"),
    /**
     * 取(排）水口流量 8
     */
    CODE_Q8("2F", "Q8"),
    /**
     * 总出库流量、过闸总流量
     */
    CODE_QA("30", "QA"),
    /**
     * 输水设备流量、过闸(组)流量
     */
    CODE_QZ("31", "QZ"),
    /**
     * 输沙量
     */
    CODE_SW("32", "SW"),
    /**
     * 风向
     */
    CODE_UC("33", "UC"),
    /**
     * 风力(级)
     */
    CODE_UE("34", "UE"),
    /**
     * 风速
     */
    CODE_US("35", "US"),
    /**
     * 断面平均流速
     */
    CODE_VA("36", "VA"),
    /**
     * 当前瞬时流速
     */
    CODE_VJ("37", "VJ"),
    /**
     * 电源电压
     */
    CODE_VT("38", "VT"),
    /**
     * 瞬时河道水位、潮位
     */
    CODE_Z("39", "Z"),
    /**
     * 库(闸、站)下水位
     */
    CODE_ZB("3A", "ZB"),
    /**
     * 库(闸、站)上水位
     */
    CODE_ZU("3B", "ZU"),
    /**
     * 取(排）水口水位 1
     */
    CODE_Z1("3C", "Z1"),
    /**
     * 取(排）水口水位 2
     */
    CODE_Z2("3D", "Z2"),
    /**
     * 取(排）水口水位 3
     */
    CODE_Z3("3E", "Z3"),
    /**
     * 取(排）水口水位 4
     */
    CODE_Z4("3F", "Z4"),
    /**
     * 取(排）水口水位 5
     */
    CODE_Z5("40", "Z5"),
    /**
     * 取(排）水口水位 6
     */
    CODE_Z6("41", "Z6"),
    /**
     * 取(排）水口水位 7
     */
    CODE_Z7("42", "Z7"),
    /**
     * 取(排）水口水位 8
     */
    CODE_Z8("43", "Z8"),
    /**
     * 含沙量
     */
    CODE_SQ("44", "SQ"),
    /**
     * 遥测站状态及报警信息
     */
    CODE_ZT("45", "ZT"),
    /**
     * pH 值
     */
    CODE_PH("46", "pH"),
    /**
     * 溶解氧
     */
    CODE_DO("47", "DO"),
    /**
     * 电导率
     */
    CODE_COND("48", "COND"),
    /**
     * 浊度
     */
    CODE_TURB("49", "TURB"),
    /**
     * 高锰酸盐指数
     */
    CODE_CODMN("4A", "CODMN"),
    /**
     * 氧化还原电位
     */
    CODE_REDOX("4B", "REDOX"),
    /**
     * 氨氮
     */
    CODE_NH4N("4C", "NH4N"),
    /**
     * 总磷
     */
    CODE_TP("4D", "TP"),
    /**
     * 总氮
     */
    CODE_TN("4E", "TN"),
    /**
     * 总有机碳
     */
    CODE_TOC("4F", "TOC"),
    /**
     * 铜
     */
    CODE_CU("50", "CU"),
    /**
     * 锌
     */
    CODE_ZN("51", "ZN"),
    /**
     * 硒
     */
    CODE_SE("52", "SE"),
    /**
     * 砷
     */
    CODE_AS("53", "AS"),
    /**
     * 总汞
     */
    CODE_THG("54", "THG"),
    /**
     * 镉
     */
    CODE_CD("55", "CD"),
    /**
     * 铅
     */
    CODE_PB("56", "PB"),
    /**
     * 叶绿素 a
     */
    CODE_CHLA("57", "CHLA"),
    /**
     * 水压 1
     */
    CODE_WP1("58", "WP1"),
    /**
     * 水压 2
     */
    CODE_WP2("59", "WP2"),
    /**
     * 水压 3
     */
    CODE_WP3("5A", "WP3"),
    /**
     * 水压 4
     */
    CODE_WP4("5B", "WP4"),
    /**
     * 水压 5
     */
    CODE_WP5("5C", "WP5"),
    /**
     * 水压 6
     */
    CODE_WP6("5D", "WP6"),
    /**
     * 水压 7
     */
    CODE_WP7("5E", "WP7"),
    /**
     * 水压 8
     */
    CODE_WP8("5F", "WP8"),
    /**
     * 水表 1 剩余水量
     */
    CODE_SYL1("60", "SYL1"),
    /**
     * 水表 2b剩余水量
     */
    CODE_SYL2("61", "SYL2"),
    /**
     * 水表 3 剩余水量
     */
    CODE_SYL3("62", "SYL3"),
    /**
     * 水表 4 剩余水量
     */
    CODE_SYL4("63", "SYL4"),
    /**
     * 水表 5 剩余水量
     */
    CODE_SYL5("64", "SYL5"),
    /**
     * 水表 6 剩余水量
     */
    CODE_SYL6("65", "SYL6"),
    /**
     * 水表 7 剩余水量
     */
    CODE_SYL7("66", "SYL7"),
    /**
     * 水表 8 剩余水量
     */
    CODE_SYL8("67", "SYL8"),
    /**
     * 水表 1 每小时水量
     */
    CODE_SBL1("68", "SBL1"),
    /**
     * 水表 2 每小时水量
     */
    CODE_SBL2("69", "SBL2"),
    /**
     * 水表 3 每小时水量
     */
    CODE_SBL3("6A", "SBL3"),
    /**
     * 水表 4 每小时水量
     */
    CODE_SBL4("6B", "SBL4"),
    /**
     * 水表 5 每小时水量
     */
    CODE_SBL5("6C", "SBL5"),
    /**
     * 水表 6 每小时水量
     */
    CODE_SBL6("6D", "SBL6"),
    /**
     * 水表 7 每小时水量
     */
    CODE_SBL7("6E", "SBL7"),
    /**
     * 水表 8 每小时水量
     */
    CODE_SBL8("6F", "SBL8"),
    /**
     * 交流 A 相电压
     */
    CODE_VTA("70", "VTA"),
    /**
     * 交流 B 相电压
     */
    CODE_VTB("71", "VTB"),
    /**
     * 交流 C 相电压
     */
    CODE_VTC("72", "VTC"),
    /**
     * 交流 A 相电流
     */
    CODE_VIA("73", "VIA"),
    /**
     * 交流 B 相电流
     */
    CODE_VIB("74", "VIB"),
    /**
     * 交流 C 相电流
     */
    CODE_VIC("75", "VIC"),
    /**
     * 累计流量
     */
    CODE_SUM_FLOW_RATE("FF01", "SUM_FLOW_RATE"),
    /**
     * 年累计流量
     */
    CODE_YEAR_SUM_FLOW_RATE("FF04", "YEAR_SUM_FLOW_RATE"),
    /**
     * 累计电量
     */
    CODE_SUM_EV("FF05", "SUM_EV"),
    /**
     * 用户号
     */
    CODE_USER_NO("FF06", "USER_NO"),
    /**
     * 测站编码 ,扩展，16位长
     */
    CODE_EXT_RTU_CODE("FF0B", "EXT_RTU_CODE"),
    /**
     * 信号强度
     */
    CODE_EXT_STATUS_SIGNAL("FF50", "EXT_STATUS_SIGNAL"),
    /**
     * 电源电压
     */
    CODE_EXT_STATUS_BV("FF51", "EXT_STATUS_BV"),
    /**
     * RTU温度
     */
    CODE_EXT_STATUS_RTU_TEMPERATURE("FF52", "EXT_STATUS_RTU_TEMPERATURE"),
    /**
     * 唯一识别码
     */
    CODE_EXT_STATUS_UUID("FF53", "EXT_STATUS_UUID"),
    /**
     * 物联卡CCID
     */
    CODE_EXT_STATUS_CCID("FF54", "EXT_STATUS_CCID"),
    /**
     * 设备状态,1字节HEX	0 - SD卡正常   1 - SD卡损坏
     */
    CODE_EXT_STATUS_RUN("FF55", "EXT_STATUS_RUN"),
    /**
     * 异常值 , 0 设备正常 , 1  设备异常 代码：
     */
    CODE_EXT_STATUS_ERROR("FF56", "EXT_STATUS_ERROR"),
    /**
     * 上报状态（每一路的上报状态）
     */
    CODE_EXT_STATUS_UP("FF57", "EXT_STATUS_UP"),
    /**
     * 上报时间
     */
    CODE_UP_TIME("FF58", "UP_TIME"),
    /**
     * 电池状态
     */
    CODE_EXT_STATUS_BT("FF59", "EXT_STATUS_BT"),
    /**
     * 充电状态
     */
    CODE_EXT_STATUS_BT_IN("FF60", "EXT_STATUS_BT_IN"),
    /**
     * 放电状态
     */
    CODE_EXT_STATUS_BT_OUT("FF61", "EXT_STATUS_BT_OUT"),
    /**
     * 电池电量
     */
    CODE_EXT_STATUS_BT_PERCENT("FF62", "EXT_STATUS_BT_PERCENT"),
    /**
     * 电池温度
     */
    CODE_EXT_STATUS_BT_TEMPERATURE("FF63", "EXT_STATUS_BT_TEMPERATURE"),
    /**
     * 阵列电压
     */
    CODE_EXT_STATUS_SUN_EV("FF64", "EXT_STATUS_SUN_EV"),
    /**
     * 阵列电流
     */
    CODE_EXT_STATUS_SUN_EA("FF65", "EXT_STATUS_SUN_EA"),
    /**
     * PM2.5
     */
    CODE_EXT_PM("FF69", "EXT_PM"),
    /**
     * 紫外线
     */
    CODE_EXT_UV("FF6A", "EXT_UV"),
    /**
     * 太阳总辐射
     */
    CODE_EXT_RAD("FF6B", "EXT_RAD"),
    /**
     * 二氧化氮
     */
    CODE_EXT_ND("FF6C", "EXT_ND"),
    /**
     * 累计流量
     */
    CODE_EXT_SUM_FLOW_RATE("FF6D", "EXT_SUM_FLOW_RATE"),
    /**
     * 山脉设备温度标识
     */
    CODE_EXT_SM_RTU_TEMPERATURE("FF80", "SM_RTU_TEMPERATURE"),
    /**
     * 山脉设备故障码标识
     */
    CODE_EXT_SM_RTU_ERROR("FF81", "SM_RTU_ERROR"),
    /**
     * 山脉设备信号强度标识
     */
    CODE_EXT_SM_RTU_SIGNAL("FF85", "SM_RTU_SIGNAL"),
    /**
     * 经度
     */
    CODE_EXT_LNG("FFB1", "LNG"),
    /**
     * 纬度
     */
    CODE_EXT_LAT("FFB2", "LAT"),
    /**
     * 版本号
     */
    CODE_EXT_RTU_VERSION("FFFE", "RTU_VERSION");

    private String code;

    private String name;

    SwElementCodeEnum(String code, String name) {
        this.code = code;
        this.name = name;
    }

    /**
     * Function:根据code来获取对应的name
     * Author: Admin
     * Date:2021/6/26
     *
     * @param code
     * @return java.lang.String
     * @throws Exception
     */
    public static String getName(String code) {
        for (SwElementCodeEnum type : SwElementCodeEnum.values()) {
            if (type.code.equals(code)) {
                return type.name;
            }
        }
        return null;
    }


    public static String getCode(String name) {
        for (SwElementCodeEnum point : SwElementCodeEnum.values()) {
            if (point.name.equals(name)) {
                return point.code;
            }
        }
        return null;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
